using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(BoxCollider))]
public partial class ArrowWall : MonoBehaviour
{
    [SerializeField] private TrapSettings _settings;
    [SerializeField] private ParticleSystem _particles;
    [SerializeField] private Killbox _killbox;

    private float _killTimer = -1;

    public void Trigger()
    {
        // TODO: pressure plate 'click' sound

        // set kill timer to zero, start counting
        _killTimer = 0;
    }

    private void Update()
    {
        if (_killTimer < 0) return;

        // TODO: implications for time freeze
        _killTimer += Time.deltaTime;
        if (_killTimer > _settings.ArrowWall.delay)
        {
            // TODO: arrow whoosh noises
            // reset
            
            _particles.Play();
            
            // kill player
            _killbox.KillPlayer();

            _killTimer = -1;
        }
    }

    public void Reset()
    {
        _killTimer = -1;
    }
}